#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}
// This script will output --virtuals and estimated-- Wh in/out and self-consumption counters into a meterN compatible format
// It is simply based on your household's production and consumption real meters. The values will be averaged during a 5 min period and will lag from 5 min.
// ln -s /srv/http/metern/comapps/eflow.php /usr/bin/eflow

// Setup your virtual meters numbers :
$whinmet  = 5; // Wh in
$whoutmet = 6; // Wh out 
$selfcmet = 7; // selfconsumption

// No edit is needed below
if (isset($argv[1])) {
    define('checkaccess', TRUE);
    include('../config/config_main.php');
    date_default_timezone_set($DTZ);
    
    for ($i = 1; $i <= $NUMMETER; $i++) { // detect the production/consumption meter
        include("../config/config_met$i.php");
        if (${'PROD' . $i} == 1) {
            $prodmet = $i;
        }
        if (${'PROD' . $i} == 2) {
            $consmet = $i;
        }
    }
    
    $dir    = '../data/csv';
    $output = array();
    $output = glob($dir . "/*.csv");
    sort($output);
    $cnt = count($output);
    
    if (file_exists($output[$cnt - 1])) {
        $file       = file($output[$cnt - 1]); // today
        $contalines = count($file);
        
        $nowutc = strtotime(date('Ymd H:i:s'));
        
        if ($contalines > 2) {
            $lastarray = preg_split("/,/", $file[$contalines-1]);
            $prevarray = preg_split("/,/", $file[$contalines-2]);
            
            $year  = substr($output[$cnt - 1], -12, 4);
            $month = substr($output[$cnt - 1], -8, 2);
            $day   = substr($output[$cnt - 1], -6, 2);
            $hour = substr($lastarray[0], 0, 2);
            $min  = substr($lastarray[0], 3, 2);
            
            $UTCdate = strtotime($year . "-" . $month . "-" . $day . " " . $hour . ":" . $min);
            $UTCdate *= 1000;
        } elseif ($contalines == 2 && file_exists($output[$cnt - 2])) { // yesterday
            $lastarray = preg_split("/,/", $file[$contalines-1]);
            
            $year  = substr($output[$cnt - 1], -12, 4);
            $month = substr($output[$cnt - 1], -8, 2);
            $day   = substr($output[$cnt - 1], -6, 2);
            $hour = substr($lastarray[0], 0, 2);
            $min  = substr($lastarray[0], 3, 2);
            
            $file = file($output[$cnt - 2]); // ytoday
            $contalines = count($file);
            $prevarray = preg_split("/,/", $file[$contalines-1]);
            
            $y_year  = substr($output[$cnt - 2], -12, 4);
            $y_month = substr($output[$cnt - 2], -8, 2);
            $y_day   = substr($output[$cnt - 2], -6, 2);
            $y_hour = substr($prevarray[0], 0, 2);
            $y_min  = substr($prevarray[0], 3, 2);
            
            $UTCdate   = strtotime($year . "-" . $month . "-" . $day . " " . $hour . ":" . $min);
            $y_UTCdate = strtotime($y_year . "-" . $y_month . "-" . $y_day . " " . $y_hour . ":" . $y_min);
            
            if ($UTCdate - $y_UTCdate <= 360) {
                $UTCdate *= 1000;
            } else {
                $UTCdate = 0; //
            }
        } else {
            $UTCdate = 0; //
        }
        
        if ($nowutc - $UTCdate < 250) {
            $val_first = trim($prevarray[$prodmet]);
            $val_last  = trim($lastarray[$prodmet]);
            settype($val_first, 'float');
            settype($val_last, 'float');
            
            if ($val_first <= $val_last) {
                $val_last -= $val_first;
            } else { // counter pass over
                $val_last += ${'PASSO' . $prodmet} - $val_first;
            }
            $housep = $val_last;
            
            $val_first = trim($prevarray[$consmet]);
            $val_last  = trim($lastarray[$consmet]);
            settype($val_first, 'float');
            settype($val_last, 'float');
            
            if ($val_first <= $val_last) {
                $val_last -= $val_first;
            } else { // counter pass over
                $val_last += ${'PASSO' . $consmet} - $val_first;
            }
            $housec = $val_last;
            
            if ($argv[1] == 'whout') {
                $val = $housep - $housec;
                if ($val < 0) {
                    $val = 0;
                }
                $val += $lastarray[$whoutmet];
                if ($val > ${'PASSO' . $whoutmet}) {
                    $val -= ${'PASSO' . $whoutmet};
                }
                $id = ${'ID' . $whoutmet};
            }
            
            if ($argv[1] == 'whin') {
                $val = $housec - $housep;
                if ($val < 0) {
                    $val = 0;
                }
                $val += $lastarray[$whinmet];
                if ($val > ${'PASSO' . $whinmet}) {
                    $val -= ${'PASSO' . $whinmet};
                }
                $id = ${'ID' . $whinmet};
            }
            
            if ($argv[1] == 'selfc') {
                $val = $housep - $housec;
                if ($housep > $housec) {
                    $val = $housec;
                } else {
                    $val = $housep;
                }
                $val += $lastarray[$selfcmet];
                if ($val > ${'PASSO' . $selfcmet}) {
                    $val -= ${'PASSO' . $selfcmet};
                }
                $id = ${'ID' . $selfcmet};
            }
        } else {
            $val = null;
        }
    } else {
    $val = null;
    }
    settype($val, 'float');
    $str = utf8_decode("$id($val*Wh)\n");
    echo "$str";
    
} else {
    die("Usage: eflow { whout | whin | selfc }\n");
}
?>
