<?php
// Credit Louviaux Jean-Marc 2014
define('checkaccess', TRUE);
include('../config/config_main.php');
include('../config/config_layout.php');

date_default_timezone_set('GMT');

if (isset($_COOKIE['user_lang'])) {
    $user_lang = $_COOKIE['user_lang'];
} else {
    $user_lang = "English";
}
include("../languages/" . $user_lang . ".php");

for ($i = 1; $i <= $NUMMETER; $i++) {
    include("../config/config_met$i.php");
}
$dir     = '../data/csv';
$output  = array();
$stack[] = array();
$output  = glob($dir . "/*.csv");
sort($output);
$cnt = count($output);

$file       = file($output[$cnt - 1]);
$contalines = count($file);

$startplot = 0;
$stopplot  = 0;
$linevalue = 0;

if ($contalines < 289 && $cnt > 1) { // Load yesterday values
    $file = file($output[$cnt - 2]);
    
    $contalines2  = count($file);
    $prevyear     = substr($output[$cnt - 2], -12, 4);
    $prevmonth    = substr($output[$cnt - 2], -8, 2);
    $prevday      = substr($output[$cnt - 2], -6, 2);
    $fileUTCdate2 = strtotime(date("$prevyear$prevmonth$prevday"));
    
    $startline = $contalines2 - 290 + $contalines; // (24*12)+2 hearder
    if ($startline < 1) {
        $startline = 2;
    }
    
    for ($line_num = $startline; $line_num < $contalines2; $line_num++) {
        $linearray    = preg_split("/,/", $file[$line_num]);
        $pastline_num = $line_num - 1;
        $prevarray    = preg_split("/,/", $file[$pastline_num]);
        
        $prevhour    = substr($prevarray[0], 0, 2);
        $prevmin     = substr($prevarray[0], 3, 2);
        $prevUTCdate = strtotime($prevyear . "-" . $prevmonth . "-" . $prevday . " " . $prevhour . ":" . $prevmin);
        $prevUTCdate *= 1000;
        
        $hour   = substr($linearray[0], 0, 2);
        $minute = substr($linearray[0], 3, 2);
        
        $UTCdate = strtotime($prevyear . "-" . $prevmonth . "-" . $prevday . " " . $hour . ":" . $minute);
        $UTCdate *= 1000;
        
        for ($i = 1; $i <= $NUMMETER; $i++) {
            if (isset($prevarray[$i]) && isset($linearray[$i])) {
                $val_first = trim($prevarray[$i]);
                $val_last  = trim($linearray[$i]);
            } else {
                $val_first = 0;
                $val_last  = 0;
            }
            if (!empty($val_first) && $line_num == $startline + 1) {
                $val_first24[$i] = $val_first;
            }
            if (!empty($val_first) && !empty($val_last) && $UTCdate - $prevUTCdate == 300000) {
                settype($val_first, 'float');
                settype($val_last, 'float');
                if (${'TYPE' . $i} != 'Sensor') { // Meter
                    if ($val_first <= $val_last) {
                        $val_last -= $val_first;
                    } else { // counter pass over
                        $val_last += ${'PASSO' . $i} - $val_first;
                    }
                }
            } else {
                $val_last = 0;
            }
            $val_last             = round($val_last, ${'PRECI' . $i});
            $stack[$i][$line_num] = array(
                $UTCdate,
                $val_last
            );
        }
    }
    $linevalue = $line_num;
}

$year  = substr($output[$cnt - 1], -12, 4);
$month = substr($output[$cnt - 1], -8, 2);
$day   = substr($output[$cnt - 1], -6, 2);

if ($contalines > 1 && $cnt > 1) { // Add the last line of previous day
    $prevarray = preg_split("/,/", $file[$contalines2 - 1]);
    
    $prevhour    = substr($prevarray[0], 0, 2);
    $prevmin     = substr($prevarray[0], 3, 2);
    $prevUTCdate = strtotime($prevyear . "-" . $prevmonth . "-" . $prevday . " " . $prevhour . ":" . $prevmin);
    $prevUTCdate *= 1000;
    
    $file      = file($output[$cnt - 1]); // Today
    $linearray = preg_split("/,/", $file[1]);
    $SDTE      = $linearray[0];
    $hour      = substr($SDTE, 0, 2);
    $minute    = substr($SDTE, 3, 2);
    $UTCdate   = strtotime($year . "-" . $month . "-" . $day . " " . $hour . ":" . $minute);
    $UTCdate *= 1000; // Should be midnight
    $plotline = $UTCdate; //plotline
    
    for ($i = 1; $i <= $NUMMETER; $i++) {
        if (isset($prevarray[$i]) && isset($linearray[$i])) {
            $val_first = trim($prevarray[$i]);
            $val_last  = trim($linearray[$i]);
        } else {
            $val_first = 0;
            $val_last  = 0;
        }
        if (!empty($val_first) && !empty($val_last) && $UTCdate - $prevUTCdate == 300000) {
            settype($val_first, 'float');
            settype($val_last, 'float');
            if (${'TYPE' . $i} != 'Sensor') { // Meter
                if ($val_first <= $val_last) {
                    $val_last -= $val_first;
                } else { // counter pass over
                    $val_last += ${'PASSO' . $i} - $val_first;
                }
            }
        } else {
            $val_last = 0;
        }
        $val_last              = round($val_last, ${'PRECI' . $i});
        $stack[$i][$linevalue] = array(
            $UTCdate,
            $val_last
        );
    }
    $linevalue++;
}

$file        = file($output[$cnt - 1]); // Today
$fileUTCdate = strtotime(date("$year$month$day"));
$todayUTC    = strtotime(date("Ymd"));

for ($line_num = 2; $line_num < $contalines; $line_num++) {
    $linearray    = preg_split("/,/", $file[$line_num]);
    $pastline_num = $line_num - 1;
    $prevarray    = preg_split("/,/", $file[$pastline_num]);
    
    $prevhour    = substr($prevarray[0], 0, 2);
    $prevmin     = substr($prevarray[0], 3, 2);
    $prevUTCdate = strtotime($year . "-" . $month . "-" . $day . " " . $prevhour . ":" . $prevmin);
    $prevUTCdate *= 1000;
    
    $SDTE   = $linearray[0];
    $hour   = substr($SDTE, 0, 2);
    $minute = substr($SDTE, 3, 2);
    
    $UTCdate = strtotime($year . "-" . $month . "-" . $day . " " . $hour . ":" . $minute);
    $UTCdate *= 1000;
    if (!isset($plotline) && $line_num == 2) {
        $plotline = $UTCdate; //plotline
    }
    
    for ($i = 1; $i <= $NUMMETER; $i++) {
        if (isset($prevarray[$i]) && isset($linearray[$i])) {
            $val_first = trim($prevarray[$i]);
            $val_last  = trim($linearray[$i]);
        } else {
            $val_first = 0;
            $val_last  = 0;
        }
        if (!empty($val_first) && !empty($val_last) && $UTCdate - $prevUTCdate == 300000) {
            settype($val_first, 'float');
            settype($val_last, 'float');
            if (${'TYPE' . $i} != 'Sensor') { // Meter
                if ($val_first <= $val_last) {
                    $val_last -= $val_first;
                } else { // counter pass over
                    $val_last += ${'PASSO' . $i} - $val_first;
                }
            }
        } else {
            $val_last = 0;
        }
        $val_last                          = round($val_last, ${'PRECI' . $i});
        $stack[$i][$line_num + $linevalue] = array(
            $UTCdate,
            $val_last
        );
    }
}

if ($fileUTCdate == $todayUTC) {
    $title = '';
} elseif ($fileUTCdate == strtotime(date("Ymd", strtotime("-1 day")))) {
    $title = stripslashes("$lgYESTERDAYTITLE");
} else {
    $dday  = date($DATEFORMAT, $fileUTCdate);
    $title = stripslashes("$dday");
}

$graphlist = array();
$unitlist  = array();

$j = 0;
for ($i = 1; $i <= $NUMMETER; $i++) {
    $prevarray = preg_split('/,/', $file[1]);
    $linearray = preg_split('/,/', $file[$contalines - 1]);
    
    if (isset($val_first24)) {
        if (!isset($val_first24[$i])) {
            $val_first24[$i] = 0;
        }
        $val_first = $val_first24[$i];
    } else {
        $val_first = trim($prevarray[$i]);
    }
    $val_last = trim($linearray[$i]);
    settype($val_first, 'float');
    settype($val_last, 'float');
    if (${'TYPE' . $i} != 'Sensor') { // Meter
        if ($val_first <= $val_last) {
            $val_last -= $val_first;
        } else { // counter pass over
            $val_last += ${'PASSO' . $i} - $val_first;
        }
    }
    if (${'PRICE' . $i} > 0) {
        $money[$i] = number_format(($val_last * ${'PRICE' . $i}), 2, $DPOINT, $THSEP);
        $money[$i] = '/' . $money[$i] . $CURS;
    } else {
        $money[$i] = '';
    }
    if (${'TYPE' . $i} == 'Elect') {
        if ($val_last <= 1000) {
            $prefix[$i] = '';
            $val_last   = number_format($val_last, 0, $DPOINT, $THSEP);
        } elseif ($val_last > 1000000) {
            $val_last /= 1000000;
            $prefix[$i] = 'M';
            $val_last   = number_format($val_last, 2, $DPOINT, $THSEP);
        } elseif ($val_last > 1000) {
            $val_last /= 1000;
            $prefix[$i] = 'k';
            $val_last   = number_format($val_last, 2, $DPOINT, $THSEP);
        }
    } else {
        $val_last   = number_format($val_last, ${'PRECI' . $i}, $DPOINT, $THSEP);
        $prefix[$i] = '';
    }
    
    $graphnum = ${'GRAPH_MET' . $i};
    if (!in_array($graphnum, $graphlist)) {
        $graphlist[]           = (int) $graphnum;
        $unitlist[$graphnum][] = ${'UNIT' . $i};
        $yaxis[$graphnum]      = (int) 0;
        
        $titlelist[$graphnum] = $title . " " . ${'METNAME' . $i} . " ($val_last$prefix[$i]${'UNIT'.$i}$money[$i]) ";
    } else {
        if (!in_array(${'UNIT' . $i}, $unitlist[$graphnum])) {
            $unitlist[$graphnum][] = ${'UNIT' . $i};
            $yaxis[$graphnum]++;
        }
        $titlelist[$graphnum] .= "- " . ${'METNAME' . $i} . " ($val_last$prefix[$i]${'UNIT'.$i}$money[$i]) ";
    }
    sort($stack[$i]);
    //sort($unitlist[$graphnum]);
    $cntunit = count($unitlist[$graphnum]);
    
    for ($h = 0; $h < $cntunit; $h++) {
        if (${'UNIT' . $i} == $unitlist[$graphnum][$h]) {
            $thisyaxis = $h;
        }
    }
    
    if (${'FILL_MET' . $i} == 0) {
        $opa = 0.5;
    } else {
        $opa = 0;
    }
    
    $data[$j] = array(
        'name' => "${'METNAME'.$i}",
        'type' => 'areaspline',
        'fillOpacity' => $opa,
        'color' => "#${'COLOR'.$i}",
        'data' => $stack[$i],
        'yAxis' => $thisyaxis
    );
    
    $j++;
}
//?sort($data); 
ksort($titlelist);
$titlelist = array_values($titlelist);

$sun_info = date_sun_info($fileUTCdate, $LATITUDE, $LONGITUDE);
if ($cnt < 2) {
    $fileUTCdate2 = $fileUTCdate;
}
$sun_info2 = date_sun_info($fileUTCdate2, $LATITUDE, $LONGITUDE);
date_default_timezone_set($DTZ); // local time
$ystrtp = date("Ymd H:i", $sun_info2['sunset']); // yestd night plotbands
$ystpp  = date("Ymd H:i", $sun_info['sunrise']);
$tstrtp = date("Ymd H:i", $sun_info['sunset']); // today
date_default_timezone_set('GMT'); // back to GMT
$ystrtp = (strtotime($ystrtp)) * 1000;
$ystpp  = (strtotime($ystpp)) * 1000;
$tstrtp = (strtotime($tstrtp)) * 1000;
$tstpp  = (strtotime($year . "-" . $month . "-" . $day . " 23:59:59")) * 1000;

$jsonreturn = array(
    'data' => $data,
    'title' => $titlelist,
    'plotline' => $plotline,
    'ystrtp' => $ystrtp,
    'ystpp' => $ystpp,
    'tstrtp' => $tstrtp,
    'tstpp' => $tstpp
);

header("Content-type: text/json");
echo json_encode($jsonreturn);
?>
